Index: tmp/org.txm.core/src/java/org/txm/Toolbox.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 313)
@@ -34,16 +34,12 @@
 import java.io.FileNotFoundException;
 import java.io.IOException;
 import java.io.InputStreamReader;
-import java.io.UnsupportedEncodingException;
-import java.util.ArrayList;
-import java.util.Arrays;
-import java.util.List;
-import java.util.Properties;
-import java.util.TreeMap;
 import java.util.logging.Level;
 
 import org.apache.commons.lang.StringUtils;
 import org.txm.core.messages.TXMCoreMessages;
+import org.txm.core.preferences.TBXPreferences;
+import org.txm.core.preferences.TXMPreferences;
 import org.txm.core.results.ITXMResult;
 import org.txm.importer.cwb.PatchCwbRegistry;
 import org.txm.objects.Base;
@@ -60,7 +56,6 @@
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.Partition;
 import org.txm.statsengine.r.core.RStatsEngine;
-import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
 import org.txm.utils.OSDetector;
 import org.txm.utils.Sh;
 import org.txm.utils.logger.Log;
@@ -73,7 +68,7 @@
  * @author jmague, mdecorde, sjacquot
  */
 public class Toolbox {
-
+/*
 	public static boolean useNetCQi = false;
 
 	/** The TXMHOME. */
@@ -91,9 +86,6 @@
 	/** The state workspace. */
 	private static boolean stateWorkspace = false;
 
-	/** The properties. */
-	private static Properties properties = new Properties();
-
 	/** The workspace. */
 	public static Workspace workspace;
 
@@ -103,8 +95,6 @@
 	/** The CQI client. */
 	private static AbstractCqiClient cqiClient;
 
-
-
 	/**
 	 * Sets the CQI server.
 	 *
@@ -141,139 +131,14 @@
 		return cqiServer;
 	}
 
-	/** The Constants for Toolbox properties. */
-	public static final String LOG_LEVEL = "log_level"; //$NON-NLS-1$
-	public static final String ADD_TECH_LOGS = "log_in_console"; //$NON-NLS-1$
-	public static final String SHOW_TIMINGS = "show_timings"; //$NON-NLS-1$
-	public static final String LOG_DIR = "log_directory"; //$NON-NLS-1$
-	public static final String LOG_IN_FILE = "log_in_file"; //$NON-NLS-1$
-	public static final String EXPERT_USER = "txm_expert_user"; //$NON-NLS-1$
-	public static final String LOG_STACKTRACE = "log_stacktrace"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_HOST. */
-	public static final String CQI_SERVER_HOST = "cqi_server_host"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_PORT. */
-	public static final String CQI_SERVER_PORT = "cqi_server_port"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_LOGIN. */
-	public static final String CQI_SERVER_LOGIN = "cqi_server_login"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_PASSWORD. */
-	public static final String CQI_SERVER_PASSWORD = "cqi_server_password"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_PATH_TO_EXECUTABLE. */
-	public static final String CQI_SERVER_PATH_TO_EXECUTABLE = "cqi_server_path_to_executable"; //$NON-NLS-1$
-
-	public static final String CQI_SERVER_PATH_TO_CQPLIB = "cqi_server_path_to_cqplib"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_PATH_TO_INIT_FILE. */
-	public static final String CQI_SERVER_PATH_TO_INIT_FILE = "cqi_server_path_to_init_file"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_ADDITIONAL_OPTIONS. */
-	public static final String CQI_SERVER_ADDITIONAL_OPTIONS = "cqi_server_additional_options"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_MONITOR_OUTPUT. */
-	public static final String CQI_SERVER_MONITOR_OUTPUT = "cqi_server_monitor_output"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_IS_REMOTE. */
-	public static final String CQI_SERVER_IS_REMOTE = "cqi_server_is_remote"; //$NON-NLS-1$
-
-	/** The Constant CQI_SERVER_MODE. */
-	public static final String CQI_NETWORK_MODE = "cqi_server_mode"; //$NON-NLS-1$
-
-	public static final String CQP_EMPTY_VALUE_CODE = "cqp_empty_value_code";
-
-
-	
-	/** The Constant SCRIPT_ROOT_DIR. */
-	public static final String SCRIPT_ROOT_DIR = "script_root_dir"; //$NON-NLS-1$
-
-	/** The Constant SCRIPT_CURRENT_DIR. */
-	public static final String SCRIPT_CURRENT_DIR = "script_current_dir"; //$NON-NLS-1$
-
-	/** The Constant UI_LOCALE. */
-	public static final String UI_LOCALE = "ui_locale"; //$NON-NLS-1$
-
-	/** The Constant WORKSPACE_LOCATION. */
-	public static final String WORKSPACE_LOCATION = "workspace_location"; //$NON-NLS-1$
-
-	/** The Constant INSTALL_DIR. */
-	public static final String INSTALL_DIR = "install_dir"; //$NON-NLS-1$
-
-	/** The Constant USER_TXM_HOME. */
-	public static final String USER_TXM_HOME = "user_txm_home"; //$NON-NLS-1$
-
-//	/** The Constant R_REMOTE. */
-//	public static final String IS_R_MANDATORY = "is_r_mandatory"; //$NON-NLS-1$
-//
-//	/** The Constant R_PATH_TO_EXECUTABLE. */
-//	public static final String R_PATH_TO_EXECUTABLE = "r_path_to_executable"; //$NON-NLS-1$
-//
-//	/** The Constant R_REMOTE. */
-//	public static final String R_REMOTE = "r_remote"; //$NON-NLS-1$
-//	public static final String R_DEBUG = "r_debug"; //$NON-NLS-1$
-//
-//	/** The Constant R_SERVER_ADDRESS. */
-//	public static final String R_SERVER_ADDRESS = "r_server_adress"; //$NON-NLS-1$
-//
-//	/** The Constant R_PORT. */
-//	public static final String R_PORT = "r_port"; //$NON-NLS-1$
-//
-//	/** The Constant R_USER. */
-//	public static final String R_USER = "r_user"; //$NON-NLS-1$
-//
-//	/** The Constant R_PASSWORD. */
-//	public static final String R_PASSWORD = "r_password"; //$NON-NLS-1$
-//
-//	/** The Constant R_PACKAGES_PATH. */
-//	public static final String R_PACKAGES_PATH = "r_packages_path"; //$NON-NLS-1$
-//
-//	public static final String R_RARGS = "r_rargs"; //$NON-NLS-1$
-//	public static final String R_RSERVEARGS = "r_rserveargs"; //$NON-NLS-1$
-//
-//	/** The Constant R_DISABLE. */
-//	public static final String R_DISABLE = "r_disable"; //$NON-NLS-1$
-//
-//	/** The Constant R_FILE_TRANSFERT. */
-//	public static final String R_FILE_TRANSFERT = "r_file_transfert"; //$NON-NLS-1$
-//	public static final String R_SVG_DEVICE = "r_svg_device"; //$NON-NLS-1$
-
-	/** The Constant TREETAGGER_INSTALL_PATH. */
-	public static final String TREETAGGER_INSTALL_PATH = "treetagger_install_path"; //$NON-NLS-1$
-	/** The Constant TREETAGGER_MODELS_PATH. */
-	public static final String TREETAGGER_MODELS_PATH = "treetagger_models_path"; //$NON-NLS-1$
-	public static final String TREETAGGER_OPTIONS = "treetagger_options"; //$NON-NLS-1$
-	public static final String TREETAGGER_APOSTROPHE = "treetagger_fix_apostrophes"; //$NON-NLS-1$
-
-	public static final String METADATA_ENCODING = "metadata_encoding"; //$NON-NLS-1$
-	public static final String METADATA_COLSEPARATOR = "metadata_colseparator"; //$NON-NLS-1$
-	public static final String METADATA_TXTSEPARATOR = "metadata_txtseparator"; //$NON-NLS-1$
-
 	private static boolean initializing = false;
 
+	private static boolean useNetCQi;
+
 	public static boolean isInitializing() {
 		return initializing;
 	}
 
-	/** Contains all the parameters keys. */
-	public static final String[] existingKeys = { LOG_LEVEL, LOG_STACKTRACE, ADD_TECH_LOGS, LOG_DIR,
-		LOG_IN_FILE, CQI_SERVER_HOST, CQI_SERVER_PORT, CQI_SERVER_LOGIN,
-		CQI_SERVER_PASSWORD, CQI_SERVER_PATH_TO_EXECUTABLE,CQI_SERVER_PATH_TO_CQPLIB,
-		CQI_SERVER_ADDITIONAL_OPTIONS, CQI_SERVER_MONITOR_OUTPUT,
-		CQI_SERVER_IS_REMOTE, CQI_NETWORK_MODE, CQP_EMPTY_VALUE_CODE, SCRIPT_ROOT_DIR,
-		SCRIPT_CURRENT_DIR, UI_LOCALE, WORKSPACE_LOCATION, INSTALL_DIR,
-		USER_TXM_HOME,
-//		IS_R_MANDATORY, R_PATH_TO_EXECUTABLE, R_DEBUG, R_REMOTE, R_SERVER_ADDRESS,
-//		R_PORT, R_USER, R_PASSWORD, R_PACKAGES_PATH, R_RARGS, R_RSERVEARGS, R_DISABLE, R_FILE_TRANSFERT,R_SVG_DEVICE,
-		
-		TREETAGGER_INSTALL_PATH, TREETAGGER_MODELS_PATH,TREETAGGER_OPTIONS, TREETAGGER_APOSTROPHE,
-		METADATA_ENCODING, METADATA_COLSEPARATOR,METADATA_TXTSEPARATOR
-
-	};
-
-
-
 	/**
 	 * Initializes the toolbox with the parameters read in the file
 	 * textometrie.properties found in the user home directory
@@ -302,28 +167,6 @@
 	}
 
 	/**
-	 * Initializes the toolbox with the parameters read in the file
-	 * textometrie.properties found in the user home directory. Web version :
-	 * check if the Toolbox is already initialized
-	 *
-	 * @return true, if successful
-	 * @throws FileNotFoundException the file not found exception
-	 * @throws IOException Signals that an I/O exception has occurred.
-	 */
-	public static boolean initialise() throws Exception {
-		initializing = true;
-		if (!isInitialized()) {
-			state = true;
-			boolean ret = initialize();
-			initializing = false;
-			return ret;
-		}
-
-		initializing = false;
-		return true;
-	}
-
-	/**
 	 * initialize the toolbox from a UTF-8 file
 	 * 
 	 * key1=value1 key2=value2.
@@ -360,7 +203,7 @@
 	public static boolean initialize(File file, String encoding) throws Exception {
 		initializing = true;
 		//System.out.println("Reading properties from file: " + file.getAbsolutePath());
-		Properties properties = new Properties();
+		//Properties properties = new Properties();
 		try {
 			BufferedReader input = new BufferedReader(new InputStreamReader(
 					new FileInputStream(file), encoding));
@@ -368,27 +211,21 @@
 			while (line != null) {
 				String[] split = line.split("="); //$NON-NLS-1$
 				if (split.length == 2) {
-					properties.put(split[0], split[1]);
+					TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, split[0], split[1]);
 				} else if (split.length > 2) {
 					String[] subsplit = new String[split.length - 1];
 					System.arraycopy(split, 1, subsplit, 0, split.length - 1);
-					properties.put(split[0], StringUtils.join(subsplit, "=")); //$NON-NLS-1$
+					TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, split[0], StringUtils.join(subsplit, "="));
 				}
 				line = input.readLine();
 			}
 			input.close();
-		} catch (UnsupportedEncodingException e) {
+		} catch (Exception e) {
 			initializing = false;
 			System.err.println(e);
-		} catch (FileNotFoundException e) {
-			initializing = false;
-			System.err.println(e);
 			throw e;
-		} catch (IOException e) {
-			initializing = false;
-			throw e;
 		}
-		return initialize(properties);
+		return initialize(TBXPreferences.class);
 	}
 
 	/**
@@ -398,140 +235,32 @@
 	 * @return true, if successful
 	 * @throws Exception 
 	 */
-	public static boolean initialize(Properties props) throws Exception {
+	public static boolean initialize(Class preferencesStore) throws Exception {
 		initializing = true;
 
 		try {
-			Log.info(TXMCoreMessages.Toolbox_4 + props.toString()); 
+			Log.info(TXMCoreMessages.Toolbox_4 + TBXPreferences.getID()); 
 
-			// Create default values for initialization
-			if (props.getProperty(INSTALL_DIR) == null)
-				props.setProperty(INSTALL_DIR, TXMINSTALL); 
-			else
-				TXMINSTALL = props.getProperty(INSTALL_DIR);
 
-			if (props.getProperty(USER_TXM_HOME) == null)
-				props.setProperty(USER_TXM_HOME, TXMHOME); 
-			else
-				TXMHOME = props.getProperty(USER_TXM_HOME);
+			TXMINSTALL = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.INSTALL_DIR);
 
-			if (props.getProperty(LOG_LEVEL) == null)
-				props.setProperty(LOG_LEVEL, "OFF"); //$NON-NLS-1$
-			if (props.getProperty(ADD_TECH_LOGS) == null)
-				props.setProperty(ADD_TECH_LOGS, "" + false); //$NON-NLS-1$
+			TXMHOME = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.USER_TXM_HOME);
 
-			if (props.getProperty(LOG_STACKTRACE) == null)
-				props.setProperty(LOG_STACKTRACE, "" + true); //$NON-NLS-1$
-			if (props.getProperty(LOG_IN_FILE) == null)
-				props.setProperty(LOG_IN_FILE, "" + false); //$NON-NLS-1$
-
-			if (props.getProperty(CQI_SERVER_PATH_TO_EXECUTABLE) == null)
-				props.setProperty(CQI_SERVER_PATH_TO_EXECUTABLE, TXMINSTALL
-						+ "/cwb/bin/cqpserver"); //$NON-NLS-1$
-			if (props.getProperty(CQI_SERVER_PATH_TO_INIT_FILE) == null)
-				props.setProperty(CQI_SERVER_PATH_TO_INIT_FILE, TXMINSTALL
-						+ "/cwb/cqpserver.init"); //$NON-NLS-1$
-			if (props.getProperty(CQI_SERVER_ADDITIONAL_OPTIONS) == null)
-				props.setProperty(CQI_SERVER_ADDITIONAL_OPTIONS, "-b 1000000 -d OFF"); //$NON-NLS-1$
-			if (props.getProperty(CQI_SERVER_PORT) == null)
-				props.setProperty(CQI_SERVER_PORT, "4877"); //$NON-NLS-1$
-			if (props.getProperty(CQI_SERVER_HOST) == null)
-				props.setProperty(CQI_SERVER_HOST, "localhost"); //$NON-NLS-1$
-			if (props.getProperty(CQI_SERVER_LOGIN) == null)
-				props.setProperty(CQI_SERVER_LOGIN, "anonymous"); //$NON-NLS-1$
-			if (props.getProperty(CQI_SERVER_PASSWORD) == null)
-				props.setProperty(CQI_SERVER_PASSWORD, ""); //$NON-NLS-1$
-			if (props.getProperty(CQI_SERVER_IS_REMOTE) == null)
-				props.setProperty(CQI_SERVER_IS_REMOTE, "" + false); //$NON-NLS-1$
-			if (props.getProperty(CQI_NETWORK_MODE) == null) {
-				props.setProperty(CQI_NETWORK_MODE, "false"); //$NON-NLS-1$
-			}
-			if (props.getProperty(CQP_EMPTY_VALUE_CODE) == null)
-				props.setProperty(CQP_EMPTY_VALUE_CODE, ""); //$NON-NLS-1$
-			if (props.getProperty(SCRIPT_ROOT_DIR) == null)
-				props.setProperty(SCRIPT_ROOT_DIR,
-						new File(TXMHOME, "scripts").getAbsolutePath()); //$NON-NLS-1$
-			if (props.getProperty(SCRIPT_CURRENT_DIR) == null)
-				props.setProperty(SCRIPT_CURRENT_DIR,
-						new File(TXMHOME, "scripts").getAbsolutePath()); //$NON-NLS-1$
-			if (props.getProperty(UI_LOCALE) == null)
-				props.setProperty(UI_LOCALE, "fr"); //$NON-NLS-1$
-			if (props.getProperty(WORKSPACE_LOCATION) == null)
-				props.setProperty(WORKSPACE_LOCATION, new File(TXMHOME, "workspaces/default.xml").getAbsolutePath()); //$NON-NLS-1$ 
-
-//			if (props.getProperty(IS_R_MANDATORY) == null)
-//				props.setProperty(IS_R_MANDATORY, "" + false); //$NON-NLS-1$
-//			if (props.getProperty(R_PATH_TO_EXECUTABLE) == null) {
-//				props.setProperty(R_PATH_TO_EXECUTABLE, ""); //$NON-NLS-1$
-//			}
-//			if (props.getProperty(R_SERVER_ADDRESS) == null)
-//				props.setProperty(R_SERVER_ADDRESS, "127.0.0.1"); //$NON-NLS-1$
-//			if (props.getProperty(R_PACKAGES_PATH) == null)
-//				props.setProperty(R_PACKAGES_PATH, ""); //$NON-NLS-1$
-//			if (props.getProperty(R_REMOTE) == null)
-//				props.setProperty(R_REMOTE, "" + false); //$NON-NLS-1$
-//			if (props.getProperty(R_DISABLE) == null)
-//				props.setProperty(R_DISABLE, "" + false); //$NON-NLS-1$
-//			if (props.getProperty(R_DEBUG) == null || props.getProperty(R_DEBUG).length() == 0)
-//				props.setProperty(R_DEBUG, "" + false); //$NON-NLS-1$
-//			if (props.getProperty(R_PORT) == null || props.getProperty(R_PORT).length() == 0)
-//				props.setProperty(R_PORT, "6311"); //$NON-NLS-1$
-//			if (props.getProperty(R_USER) == null)
-//				props.setProperty(R_USER, ""); //$NON-NLS-1$
-//			if (props.getProperty(R_PASSWORD) == null)
-//				props.setProperty(R_PASSWORD, ""); //$NON-NLS-1$
-//			if (props.getProperty(R_RARGS) == null)
-//				props.setProperty(R_RARGS, ""); //$NON-NLS-1$
-//			if (props.getProperty(R_RSERVEARGS) == null)
-//				props.setProperty(R_RSERVEARGS, ""); //$NON-NLS-1$
-//			if (props.getProperty(R_FILE_TRANSFERT) == null)
-//				props.setProperty(R_FILE_TRANSFERT, "false"); //$NON-NLS-1$
-//			if (props.getProperty(R_SVG_DEVICE) == null) {
-//				props.setProperty(R_SVG_DEVICE, "svg"); //$NON-NLS-1$
-//			}
-
-			if (props.getProperty(TREETAGGER_INSTALL_PATH) == null
-					|| props.getProperty(TREETAGGER_INSTALL_PATH).equals("")) //$NON-NLS-1$
-				props.setProperty(TREETAGGER_INSTALL_PATH, System
-						.getProperty("user.home") + "/TXM/treetagger"); //$NON-NLS-1$ //$NON-NLS-2$
-			if (props.getProperty(TREETAGGER_MODELS_PATH) == null
-					|| props.getProperty(TREETAGGER_MODELS_PATH).equals("")) //$NON-NLS-1$
-				props.setProperty(TREETAGGER_MODELS_PATH, props
-						.getProperty(TREETAGGER_INSTALL_PATH) + "/models"); //$NON-NLS-1$
-			if (props.getProperty(TREETAGGER_APOSTROPHE) == null
-					|| props.getProperty(TREETAGGER_APOSTROPHE).equals("")) //$NON-NLS-1$
-				props.setProperty(TREETAGGER_APOSTROPHE, "false"); //$NON-NLS-1$
-
-			if (props.getProperty(METADATA_COLSEPARATOR) == null || props.getProperty(METADATA_COLSEPARATOR).length() == 0)
-				props.setProperty(METADATA_COLSEPARATOR, ","); //$NON-NLS-1$
-			if (props.getProperty(METADATA_ENCODING) == null || props.getProperty(METADATA_ENCODING).length() == 0)
-				props.setProperty(METADATA_ENCODING, "UTF-8"); //$NON-NLS-1$
-			if (props.getProperty(METADATA_TXTSEPARATOR) == null)
-				props.setProperty(METADATA_TXTSEPARATOR, "\""); //$NON-NLS-1$
-
-			properties = props;
-
 			// initialize workspace : list of corpus loaded in TXM
 			stateWorkspace = startWorkspace();
 
 			Log.warning("Initializing logger");
-			Log.setLevel(Level.parse(props.getProperty(LOG_LEVEL)));
-			//System.out.println("log_in_file: "+props.getProperty(LOG_FILE));
-			Log.setPrintInConsole(Boolean.parseBoolean(props.getProperty(ADD_TECH_LOGS)));
-			//System.out.println("LOG in file: "+props.getProperty(LOG_IN_FILE)+ " -> "+Boolean.parseBoolean(props.getProperty(LOG_IN_FILE)));
-			if(props.getProperty(LOG_DIR) != null)
-				Log.setPrintInFile(Boolean.parseBoolean(props.getProperty(LOG_IN_FILE)), new File(props.getProperty(LOG_DIR)));
-			else
-				Log.setPrintInFile(Boolean.parseBoolean(props.getProperty(LOG_IN_FILE)));
+			Log.setLevel(Level.parse(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.LOG_LEVEL)));
 
-			useNetCQi = Boolean.parseBoolean(props.getProperty(CQI_NETWORK_MODE));
-			//System.out.println("CQI MODE NETWORK : "+useNetCQi);
+			Log.setPrintInConsole(Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.ADD_TECH_LOGS)));
 
-			Log.info(TXMCoreMessages.Toolbox_8 + checkInexistantParameterKey(props)); 
-			Log.info(TXMCoreMessages.Toolbox_9 + getSortedPropertiesAsString()); 
+			if(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.LOG_DIR) != null)
+				Log.setPrintInFile(Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.LOG_IN_FILE)), new File(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.LOG_DIR)));
+			else
+				Log.setPrintInFile(Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.LOG_IN_FILE)));
 
-			// start engines then the workspace
-			//System.out.println("REMOTE CQP: "+props.getProperty(CQI_SERVER_IS_REMOTE));
+			useNetCQi = Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_NETWORK_MODE));
+
 			Log.warning("Killing CQP and RServe process if any");
 			processKiller();
 
@@ -549,23 +278,6 @@
 	}
 
 	/**
-	 * find the keys not used by the Toolbox.
-	 *
-	 * @param p the p
-	 * @return the list
-	 */
-	public static List<String> checkInexistantParameterKey(Properties p) {
-		List<String> existingkeys = Arrays.asList(existingKeys);
-		List<String> missingkeys = new ArrayList<String>();
-		for (Object key : p.keySet()) {
-			String skey = key.toString();
-			if (!existingkeys.contains(skey))
-				missingkeys.add(skey);
-		}
-		return missingkeys;
-	}
-
-	/**
 	 * if searchengine or statengine or workspace is not ready then the toolbox
 	 * is not ready.
 	 *
@@ -579,6 +291,7 @@
 		return state;
 	}
 
+	/*
 	/**
 	 * start the workspace, creates a new one if WORKSPACE_LOCATION is wrong.
 	 *
@@ -587,12 +300,12 @@
 	private static boolean startWorkspace() {
 		try {
 			System.out.print(TXMCoreMessages.Toolbox_workspace_init);
-			String txmhome = getParam(USER_TXM_HOME);
+			String txmhome = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.USER_TXM_HOME);
 			if (txmhome.length() == 0) {
 				stateWorkspace = false;
 				return false;
 			}
-			String location = properties.getProperty(WORKSPACE_LOCATION);
+			String location = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.WORKSPACE_LOCATION);
 			
 			System.out.println("Toolbox.startWorkspace(): workspace location = " + location);
 			
@@ -638,7 +351,7 @@
 			 */
 
 		} catch (Exception e) {
-			System.err.println(TXMCoreMessages.Toolbox_workspace_init_failed + properties.getProperty(WORKSPACE_LOCATION)); 
+			System.err.println(TXMCoreMessages.Toolbox_workspace_init_failed + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.WORKSPACE_LOCATION)); 
 			Log.severe(TXMCoreMessages.Toolbox_15 + Log.toString(e));
 			Log.printStackTrace(e);
 			stateWorkspace = false;
@@ -662,12 +375,11 @@
 		}
 
 		boolean cqiserverok = false;
-		boolean remote = Boolean.parseBoolean(properties
-				.getProperty(Toolbox.CQI_SERVER_IS_REMOTE));
+		boolean remote = Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_IS_REMOTE));
 		stateSearchEngine = false;
 		// test if must-have properties for CWB are set
 
-		String exec_path = properties.getProperty(CQI_SERVER_PATH_TO_EXECUTABLE);
+		String exec_path = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PATH_TO_EXECUTABLE);
 		String reg_path = ""; // new way that concats registry of loaded corpus
 		String path_separator = System.getProperty("path.separator");
 		for (Base b : workspace.getProject("default").getBases()) {
@@ -693,7 +405,7 @@
 		}
 		if (reg_path.length() > 0) reg_path = reg_path.substring(path_separator.length()); // remove first path_separator
 		//System.out.println("REGPATH="+reg_path);
-		String init_path = properties.getProperty(CQI_SERVER_PATH_TO_INIT_FILE);
+		String init_path = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PATH_TO_INIT_FILE);
 
 
 		if (!remote) {
@@ -707,10 +419,9 @@
 						Toolbox.cqiServer = new MemCqiServer(exec_path,
 								reg_path, 
 								init_path, 
-								properties.getProperty(CQI_SERVER_ADDITIONAL_OPTIONS)
-								+ " -P " + properties.getProperty(CQI_SERVER_PORT), //$NON-NLS-1$
-								Boolean.parseBoolean(properties
-										.getProperty(CQI_SERVER_MONITOR_OUTPUT)));
+								TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_ADDITIONAL_OPTIONS)
+								+ " -P " + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT), //$NON-NLS-1$
+								Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_MONITOR_OUTPUT)));
 					} catch (Exception e) {
 						// TODO Auto-generated catch block
 						org.txm.utils.logger.Log.printStackTrace(e);
@@ -719,10 +430,9 @@
 					Toolbox.cqiServer = new NetCqiServer(exec_path,
 							reg_path, 
 							init_path, 
-							properties.getProperty(CQI_SERVER_ADDITIONAL_OPTIONS)
-							+ " -P " + properties.getProperty(CQI_SERVER_PORT), //$NON-NLS-1$
-							Boolean.parseBoolean(properties
-									.getProperty(CQI_SERVER_MONITOR_OUTPUT)));
+							TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_ADDITIONAL_OPTIONS)
+							+ " -P " + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT), //$NON-NLS-1$
+							Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_MONITOR_OUTPUT)));
 				}
 				if (Toolbox.cqiServer != null)
 					cqiserverok = Toolbox.cqiServer.start();
@@ -740,22 +450,22 @@
 						cqiserverok = false;
 					}
 				} else {
-					int port = Integer.parseInt(properties.getProperty(CQI_SERVER_PORT));
-					String host = properties.getProperty(CQI_SERVER_HOST);
+					int port = Integer.parseInt(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT));
+					String host = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_HOST);
 					cqiClient = new NetCqiClient(host, port);
 				}
 			}
 		} catch (NumberFormatException e1) {
-			Log.severe(TXMCoreMessages.Toolbox_wrong_port + properties.getProperty(CQI_SERVER_PORT)); 
+			Log.severe(TXMCoreMessages.Toolbox_wrong_port + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT)); 
 		} catch (ServerNotFoundException e1) {
-			Log.severe(TXMCoreMessages.Error_CONNECTION_FAILED + properties.getProperty(CQI_SERVER_HOST) + TXMCoreMessages.Toolbox_27 + properties.getProperty(CQI_SERVER_PORT)); 
+			Log.severe(TXMCoreMessages.Error_CONNECTION_FAILED + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_HOST) + TXMCoreMessages.Toolbox_27 + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT)); 
 		}
 
 		// try connecting to the CWB server
 		try {
 			if (cqiserverok) {
-				String login = properties.getProperty(CQI_SERVER_LOGIN);
-				String password = properties.getProperty(CQI_SERVER_PASSWORD);
+				String login = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_LOGIN);
+				String password = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PASSWORD);
 				stateSearchEngine = cqiClient.connect(login, password);
 			}
 		} catch (Exception e1) {
@@ -764,7 +474,10 @@
 
 		if (stateSearchEngine == false) {
 			System.out.println(TXMCoreMessages.Toolbox_29); 
-			System.out.println(TXMCoreMessages.Toolbox_30 + properties.getProperty(CQI_SERVER_LOGIN) + " " + properties.getProperty(CQI_SERVER_PASSWORD) + properties.getProperty(CQI_SERVER_HOST) + " " + Integer.parseInt(properties.getProperty(CQI_SERVER_PORT))); //$NON-NLS-1$ //$NON-NLS-2$
+			System.out.println(TXMCoreMessages.Toolbox_30 + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_LOGIN) 
+					+ " " + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PASSWORD) 
+					+ TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_HOST) 
+					+ " " + Integer.parseInt(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT))); //$NON-NLS-1$ //$NON-NLS-2$
 			if (cqiServer != null)
 				System.out.println(TXMCoreMessages.Toolbox_33 + cqiServer.getLastCmdLine());
 		} else {
@@ -807,7 +520,7 @@
 	 * kill cqpserver process.
 	 */
 	private static void killSearchEngine() {
-		if ("false".equals(getParam(CQI_SERVER_IS_REMOTE))) //$NON-NLS-1$
+		if ("false".equals(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_IS_REMOTE))) //$NON-NLS-1$
 			// Windows OS
 			if (OSDetector.isFamilyWindows()) {
 				try {
@@ -840,23 +553,23 @@
 			}
 		// Mac, Linux
 			else {
-				String cmd = TXMCoreMessages.Toolbox_37 + getParam(CQI_SERVER_PORT) + TXMCoreMessages.Toolbox_38;
+				String cmd = TXMCoreMessages.Toolbox_37 + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT) + TXMCoreMessages.Toolbox_38;
 				try {
 					//Process p = Runtime.getRuntime().exec("killall -9 cqpserver"); //$NON-NLS-1$
 					// System.out.println("kill `ps aux | grep cqpserver | awk '/-P "
-					// + getParam(CQI_SERVER_PORT) + "/ {print $2}'`");
+					// + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, CQI_SERVER_PORT) + "/ {print $2}'`");
 					// String[] args =
 					// {"kill","`ps aux | grep cqpserver | awk '/-P " +
-					// getParam(CQI_SERVER_PORT) + "/ {print $2}'`"};
+					// TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, CQI_SERVER_PORT) + "/ {print $2}'`"};
 					// System.out.println("before Sh constructor");
 					Sh sh = new Sh(""); //$NON-NLS-1$
 					// System.out.println("after Sh constructor");
 					// System.out.println("EXECUTE SH : "+"kill `ps aux | grep cqpserver | awk '/-P "
-					// + getParam(CQI_SERVER_PORT) + "/ {print $2}'`");
+					// + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, CQI_SERVER_PORT) + "/ {print $2}'`");
 					sh.setIsc(cmd);
 					sh.sh();
 					// Runtime.getRuntime().exec("sh kill `ps aux | grep cqpserver | awk '/-P "
-					// + getParam(CQI_SERVER_PORT) + "/ {print $2}'`");
+					// + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, CQI_SERVER_PORT) + "/ {print $2}'`");
 
 				} catch (Exception e) {
 					Log.severe(TXMCoreMessages.Toolbox_39+cmd+TXMCoreMessages.Toolbox_40+Log.toString(e));
@@ -1035,71 +748,11 @@
 	 */
 	public static boolean restart() throws Exception {
 		Toolbox.shutdown();
-		Toolbox.initialize(properties);
+		Toolbox.initialize(TBXPreferences.class);
 		return checkState();
 	}
 
 	/**
-	 * Update the toolbox properties.
-	 *
-	 * @param props the props
-	 */
-	public static void updateProperties(Properties props) {
-		for (Object okey : props.keySet()) {
-			String key = (String) okey;
-			//System.out.println("maj TBX prop "+key+" with "+props.get(key));
-
-			if (props.get(key) == null) {
-				Log.severe(TXMCoreMessages.Toolbox_2 + key);
-			}
-			else	{
-				properties.put(key, props.get(key));
-			}
-		}
-		Log.setLevel(Level.parse(getParam(LOG_LEVEL)));
-		Log.info(TXMCoreMessages.Toolbox_11 + getSortedPropertiesAsString());
-	}
-
-	/**
-	 * Shut the toolbox down. Web version : change the toolbox state
-	 *
-	 * @throws RWorkspaceException the r workspace exception
-	 */
-	public static void shutdoweb() throws RWorkspaceException {
-		if (isInitialized()) {
-			shutdown();
-			state = false;
-		}
-	}
-
-	/**
-	 * get the string value of a toolbox's parameter
-	 * 
-	 * ex : Toolbox.getParam(Toolbox.R_Path_To_EXECUTABLE)
-	 *
-	 * @param key the key
-	 * @return the param
-	 */
-	public static String getParam(String key) {
-		if (properties != null)
-			return properties.getProperty(key);
-		else
-			return "ERROR WHILE GETTING TXM PARAM"; //$NON-NLS-1$
-	}
-
-	/**
-	 * set the string value of a toolbox's parameter
-	 * 
-	 * ex : Toolbox.setParam(Toolbox.R_Path_To_EXECUTABLE,"")
-	 *
-	 * @param key the key
-	 * @param value the value
-	 */
-	public static void setParam(String key, Object value) {
-		properties.setProperty(key, value.toString());
-	}
-
-	/**
 	 * test if searchEngine and statEngine and Workspace are initialized.
 	 *
 	 * @return true, if is initialized
@@ -1118,6 +771,17 @@
 	}
 
 	/**
+	 * Use TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, key) instead
+	 * 
+	 * @param key
+	 * @return
+	 */
+	@Deprecated
+	public static String getParam(String key) {
+		return TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, key);
+	}
+	
+	/**
 	 * test if StatEngine is initialized.
 	 *
 	 * @return true, if is initialized
@@ -1126,15 +790,6 @@
 		return RStatsEngine.isStarted();
 	}
 
-	/**
-	 * return all the properties of the toolbox.
-	 *
-	 * @return the properties
-	 */
-	public static Properties getProperties() {
-		return properties;
-	}
-
 	/* (non-Javadoc)
 	 * @see java.lang.Object#finalize()
 	 */
@@ -1146,15 +801,18 @@
 			super.finalize();
 		}
 	}
-
-	
-	
-	
 	/**
-	 * Returns a string representation of sorted properties.
+	 * use TBXPreferences.setString(key, value) instead
+	 * 
+	 * @param key
+	 * @param value
 	 */
-	public static String getSortedPropertiesAsString()	{
-		TreeMap treeMap = new TreeMap(properties);
-		return treeMap.toString();
+	@Deprecated
+	public static void setParam(String key, String value) {
+		TXMPreferences.putString(TBXPreferences.PREFERENCES_NODE, key, value);
 	}
+
+	public static void preferencesUpdated() {
+		// TODO Auto-generated method stub
+	}
 }
